#
# spec file for package perl-Data-Visitor
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-Data-Visitor
Version:        0.30
Release:        3.5
%define cpan_name Data-Visitor
Summary:        Visitor style traversal of Perl data structures
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/Data-Visitor/
Source:         http://www.cpan.org/authors/id/D/DO/DOY/%{cpan_name}-%{version}.tar.gz
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(Class::Load) >= 0.06
BuildRequires:  perl(Moose) >= 0.89
BuildRequires:  perl(Task::Weaken)
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(Test::Requires)
BuildRequires:  perl(Tie::ToObject) >= 0.01
BuildRequires:  perl(namespace::clean) >= 0.19
#BuildRequires: perl(Data::Visitor)
#BuildRequires: perl(Data::Visitor::Callback)
#BuildRequires: perl(Sub::Name)
Requires:       perl(Class::Load) >= 0.06
Requires:       perl(Moose) >= 0.89
Requires:       perl(Task::Weaken)
Requires:       perl(Tie::ToObject) >= 0.01
Requires:       perl(namespace::clean) >= 0.19
%{perl_requires}

%description
This module is a simple visitor implementation for Perl values.

It has a main dispatcher method, 'visit', which takes a single perl value
and then calls the methods appropriate for that value.

It can recursively map (cloning as necessary) or just traverse most
structures, with support for per object behavior, circular structures,
visiting tied structures, and all ref types (hashes, arrays, scalars, code,
globs).

the Data::Visitor manpage is meant to be subclassed, but also ships with a
callback driven subclass, the Data::Visitor::Callback manpage.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes LICENSE README

%changelog
* Thu Jul 18 2013 coolo@suse.com
- updated to 0.30
  - doy/data-visitor should probably be the canonical repository at this
    point
  - The class callbacks to be run for an object are now chosen once, at the
    start of visiting that object. Previously, it always looked through the
    entire list of callbacks every time, in a loop in which the object in
    question could be changed by the callback. Since the class callbacks are
    only partially ordered, this lead to differences in whether a callback
    would be called or not based on hash order. reported by Robin Smidsrød.
* Mon Feb 27 2012 coolo@suse.com
- updated to 0.28
  - convert to dzil
  - bump namespace::clean dep
  - better error message if Data::Alias isn't found
  - doc fixes
* Thu Jul 14 2011 coolo@novell.com
- regenerate with cpanspec
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Mon Nov 29 2010 coolo@novell.com
- remove /var/adm/perl-modules
* Sat Jul 24 2010 pascal.bleser@opensuse.org
- initial package (0.27)
